package chap03.program06;
import java.util.*;

public class AnonInnerClassTest {
    public static void main(String[] args) throws Exception {
        MyObservable observable = new MyObservable();
        final int counter[] = new int[1];
        observable.addObserver(new Observer() {
            public void update(Observable o, Object arg) {
                // 変更通知を受け取り、カウンタ値を更新
                System.out.println(++counter[0]);
            }
        });

        for (int i = 0; i < 5; i++) {
            observable.change();           // Observableの状態を変更
            observable.notifyObservers();  // Observerに状態変更を通知
        }
    }
}

class MyObservable extends Observable {
    public void change() {
        setChanged();
    }
}
