package chap08.misc;

import java.util.ArrayList;
import java.util.List;

class JavaHelloMonitor {
    // 共有リソース
    private List<Integer> values = new ArrayList<Integer>();

    // ①thisオブジェクトのロックを取得
    public synchronized long take() throws InterruptedException {
        // ②処理実行の条件が満たされるまで待機(wait)する。通知(notify)
        // を受けて処理を再開すると、ロックを取得した状態になる
        while (values.size() == 0) {
            wait();
        }
        // ③処理の実行
        return values.remove(0); // 先頭の要素を返す
    } // ④ロックの解放

    // ①thisオブジェクトのロックを取得
    public synchronized void put(int value)
            throws InterruptedException {
        // ②処理の実行
        values.add(value);
        // ③待機(wait)状態のスレッドへの通知(notifyAll)
        notifyAll();
    } // ④ロックの解放
}
