package chap09.program02

import scala.actors._
import scala.actors.Actor._

case class End
//case class End()
object HelloActor {
  def main(args: Array[String]) : Unit = {
    // リスト2 アクターを使った簡単なプログラム
    val helloActor = actor {
      loop {
        react { // メッセージの受信
          case m:String => println("Got a message: " + m)
          case End => println("End."); System.exit(0)
        }
      }
    }
    // リスト3 loopを記述しない場合
//    val helloActor = actor {
//      react { // メッセージの受信
//        case m:String => println("Got a message: " + m)
//        case End => println("End."); System.exit(0)
//      }
//    }
    helloActor.start // 待ち受け側アクターの処理開始

    for (i <- 1 to 3) {
      // アクターへのメッセージの送信
      helloActor ! "Hello, Actor World! " + i
      Thread.sleep(1000L)
    }
    helloActor ! End // 「終了」メッセージの送信
  }
}
