package chap10.program08

import chap10.program07._

object CombinatorParserTest3 {
  def main(args: Array[String]) : Unit = {
    test("Test1: ", "1 + 2")
    test("Test2: ", "10 * 5 - 2 + 3")
    test("Test3: ", "24 / (2 + 4)")
    test("Test4: ", "1 + 2 * (6 / 2) - 5")
  }

  def test(caption: String, data: String) {
    print(caption + data)
    val result = new CombinatorParser3().parse(data)
    if (result.successful)
      println(" ==> " + eval(result.get))
    else
      println(" ==> " + result)
  }

  def eval(ir:IR2): Double = ir match {
    case Operator("+", opr1, opr2) => eval(opr1) + eval(opr2)
    case Operator("-", opr1, opr2) => eval(opr1) - eval(opr2)
    case Operator("*", opr1, opr2) => eval(opr1) * eval(opr2)
    case Operator("/", opr1, opr2) => eval(opr1) / eval(opr2)
    case Number(n) => n
  }
}

